@ECHO OFF
cls
setlocal EnableDelayedExpansion
for /f "delims=" %%X in ('echo %0') do (
set cmddrive=%%~dX
@ECHO CMD File Drive: !cmddrive!
set cmdpath=%%~pX
@ECHO CMD File Path: !cmdpath!
set cmdfilename=%%~nX
@ECHO CMD File Name: !cmdfilename!
set cmdfileext=%%~xX
@ECHO CMD File Ext: !cmdfileext!
@ECHO --- ---
rem for /f "delims=" %%X in ('echo %0') do (
)
set currentprogramcmd=%cmdfilename%.cmd
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo %date% %time%
echo Running program: %currentprogramcmd%
echo Located in directory: %cmddrive%%cmdpath%
set pgmver=0.6
echo Ver. %pgmver%
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
pushd %~dp0
rem Program control file name
if [%1] NEQ [] (
set pgmcontrol=%1
rem if [%1] NEQ [] (
) else (
set pgmcontrol=.\%cmdfilename%-control.ini
rem if [%1] NEQ [] ) else (
)
@ECHO Running with program control file: %pgmcontrol%
@ECHO --- ---
rem --- ---
rem Computer to generate report for
set runforcomputer=%computername%
rem --- ---
rem Extract schedule info file prefix
set boincinfofileprefix=sched_
rem --- ---
rem Extract schedule unique file identifier
set boincschedfileunique=-001
rem --- ---
rem pause for extract file review
set pauseforextractfilereview=no
rem --- ---
rem Save schedule files with unknown errors
set saveschedunknownfiles=yes
rem --- ---
rem Save schedule files with unknown error prefix
set boincinfofileunknownprefix=unknown-error-sched_
rem --- ---
rem Days to generate report
set check_days=2
rem --- ---
rem Collect data from stdoutdae.txt boinc log files set to no to run with files you have already
set readstdoutdaefiles=yes
rem --- ---
rem date range
rem start with this date  - must match PC date format
set datetostrtwith=11/20/2012
rem set datetostrtwith=today
if %datetostrtwith% EQU today set datetostrtwith=%date%
rem (set datetostrtwith=)
rem --- ---
rem end with this date - must match PC date format
set datetoendwith=11/01/2012
rem (set datetoendwith=)
rem --- ---
rem Boinc project to look for
set logdataproject=[SETI@home]
rem --- ---
rem schedule success extract file
set successfile=%boincinfofileprefix%successes-%runforcomputer%%boincschedfileunique%.txt
rem --- ---
rem schedule failure extract file
set failurefile=%boincinfofileprefix%failures-%runforcomputer%%boincschedfileunique%.txt
rem --- ---
rem PC date delimiter
set pcdatefmtdelim=/
rem --- ---
rem PC date format
set pcdatefmt=m/d/y
rem --- ---
rem PC time delimiter
set pctimefmtdelim=:
rem --- ---
rem stdoutdae.txt date delimiter
set logdatefmtdelim=-
rem --- ---
rem stdoutdae.txt date format
rem 3cm will get three character month name
set logdatefmt=d-3cm-y
rem --- ---
rem list of files to process
set listoffiles=.\%cmdfilename%-filelist.txt
rem --- ---
rem registry value boinc data directory
@ECHO Registry values Start
(set boincdatadir=)
set key_name=HKEY_LOCAL_MACHINE\SOFTWARE\Space Sciences Laboratory, U.C. Berkeley\BOINC Setup
set value_name=DATADIR
call :boincregistry boincdatadir
rem override registry value with following line
rem set boincdatadir=c:\whateveryouwant\
@ECHO Boinc Data Directory: %boincdatadir%
rem set tdate=08/02/2090
call :datetimeforrun
set outfndtdt=%outfndtdttemp%
set outfndttm=%outfndttmtemp%
@ECHO --- ---
rem Collect log data type csv
set writelogdatatofilecsv=yes
rem --- ---
rem Save report to txt file
set writelogdatatofilerpt=yes
rem --- ---
rem produce report detail
set writereportdetail=yes
rem --- ---
rem produce report item assigned work details
set writeassignedwork=yes
rem --- ---
rem produce report item success failure percentage
set writesuccessfailurepercentage=yes
rem --- ---
rem produce report item percentage of schedule failures to all schedule failures
set writepercentageofschedfailuretoallschedfailures=yes
rem --- ---
rem produce report item percentage of schedule failures to all schedule requests
set writepercentageofschedfailuretoallschedrequests=yes
rem --- ---
rem produce report total
set writereporttotal=yes
rem --- ---
set writelogdatatofile=no
if %writelogdatatofilecsv% EQU yes set writelogdatatofile=yes
if %writelogdatatofilerpt% EQU yes set writelogdatatofile=yes
if %writelogdatatofile% EQU yes (
@ECHO File name Date: %outfndtdt%
@ECHO File name Time: %outfndttm%
rem File name used to save data in csv format
set logdatafilecsv=.\%cmdfilename%-logdata-csv-%outfndtdt%%outfndttm%.csv
rem --- ---
rem File name used to save Report lines
set logdatafilerpt=.\%cmdfilename%-logdata-rpt-%outfndtdt%%outfndttm%.txt
rem --- ---
if %writelogdatatofilecsv% EQU yes @ECHO Saving CSV Data to: !logdatafilecsv!
if %writelogdatatofilerpt% EQU yes @ECHO Saving RPT Data to: !logdatafilerpt!
@ECHO --- ---
rem if %writelogdatatofile% EQU yes (
)
set schedsuccess=Scheduler request completed:
set schedfailure=Scheduler request failed:
rem scheduler failure type to track
set schedfailure1=Timeout was reached
set schedfailure2=Couldn't connect to server
set schedfailure3=Failure when receiving data from the peer
set schedfailure4=Server returned nothing (no headers, no data)
set schedfailure5=Couldn't resolve host name
set schedfailure6=HTTP internal server error
set schedfailure7=HTTP service unavailable
set schedfailureitems=0
for /L %%C in (1,1,25) DO (
if defined schedfailure%%C (
set /A schedfailureitems=schedfailureitems+1
rem if defined schedfailure%%C (
)
rem do /L %%C in (1,1,25) DO (
)
rem month abbrevations 
set mname01=Jan
set mname02=Feb
set mname03=Mar
set mname04=Apr
set mname05=May
set mname06=Jun
set mname07=Jul
set mname08=Aug
set mname09=Sep
set mname10=Oct
set mname11=Nov
set mname12=Dec
rem --- ---
set schedfileprefixincntl=no
if exist "%pgmcontrol%" (
@ECHO Processing control file - Start
FOR /F "tokens=1,2* delims=$" %%A IN ('type "%pgmcontrol%"') DO (
set setvlu=%%A
call set setvluto=%%~B
if /i !setvlu! EQU boincinfofileprefix set schedfileprefixincntl=yes
if /i !setvlu! NEQ rem (
if /i !setvluto! EQU nothing (
(set !setvlu!=)
rem if /i !setvluto! EQU nothing (
) else (
set !setvlu!=!setvluto!
rem if /i !setvluto! EQU nothing ) else (
)
@ECHO set !setvlu! to value: !setvluto!
if /i !setvluto! EQU today (
set setvluto=%date%
set !setvlu!=!setvluto!
@ECHO set !setvlu! to value: !setvluto!
rem if /i !setvluto! EQU today (
)
rem if /i !setvlu! NEQ rem (
)
rem FOR /F "tokens=*" %%A IN ('type "%pgmcontrol%"') DO (
)
@ECHO Processing control file - Complete
@ECHO --- ---
rem if exist %pgmcontrol% (
) else (
@ECHO Program control file: %pgmcontrol% - was not found.
@ECHO Running with program defaults.
rem if exist %pgmcontrol% ) else (
)
if !schedfileprefixincntl! EQU yes (
set successfile=%boincinfofileprefix%successes-%runforcomputer%%boincschedfileunique%.txt
set failurefile=%boincinfofileprefix%failures-%runforcomputer%%boincschedfileunique%.txt
rem if !schedfileprefixincntl! EQU yes (
)
rem goto :endthis
   ::::::::::::::::::::::::::::::::::::::::::::::::::
   ::::::::::::::::::::::::::::::::::::::::::::::::::
rem Not much needs to be change blow here
   ::::::::::::::::::::::::::::::::::::::::::::::::::
   ::::::::::::::::::::::::::::::::::::::::::::::::::
rem output format filler
set outputfiller=`````````````````````````````````````````````````````````````````````````````````````
rem ---
rem output put value here
set putvaluehere=47
rem ---
rem output put value here
set putvalueherevalue=7
rem ---
@ECHO Running with values:
(set outputpart1=Computer name )
(set outputpart2=value: %runforcomputer% )
call :eocuhtotheline
(set outputpart1=Boinc schedule info extract file prefix )
(set outputpart2=value: %boincinfofileprefix% )
call :eocuhtotheline
(set outputpart1=Boinc schedule info extract file unique )
(set outputpart2=value: %boincschedfileunique% )
call :eocuhtotheline
(set outputpart1=Pause for extract file review)
(set outputpart2=value: %pauseforextractfilereview% )
call :eocuhtotheline
(set outputpart1=Save schedule files with unknown errors )
(set outputpart2=value: %saveschedunknownfiles% )
call :eocuhtotheline
(set outputpart1=Save schedule files with unknown error prefix )
(set outputpart2=value: %boincinfofileunknownprefix% )
call :eocuhtotheline
(set outputpart1=Days to run for )
(set outputpart2=value: %check_days% )
call :eocuhtotheline
(set outputpart1=Extract data from stdoutdae.txt files )
(set outputpart2=value: %readstdoutdaefiles% )
call :eocuhtotheline
(set outputpart1=Date Range Start date )
(set outputpart2=value: %datetostrtwith% )
call :eocuhtotheline
(set outputpart1=Date Range End date )
(set outputpart2=value: %datetoendwith% )
call :eocuhtotheline
(set outputpart1=Boinc Project to report on )
(set outputpart2=value: %logdataproject% )
call :eocuhtotheline
(set outputpart1=Schedule success extract file )
(set outputpart2=value: %successfile% )
call :eocuhtotheline
(set outputpart1=Schedule failure extract file )
(set outputpart2=value: %failurefile% )
call :eocuhtotheline
(set outputpart1=Running computer Date delimiter )
(set outputpart2=value: %pcdatefmtdelim% )
call :eocuhtotheline
(set outputpart1=Running computer Date format )
(set outputpart2=value: %pcdatefmt% )
call :eocuhtotheline
(set outputpart1=Running computer Time delimiter )
(set outputpart2=value: %pctimefmtdelim% )
call :eocuhtotheline
(set outputpart1=Log stdoudea.txt Date delimiter )
(set outputpart2=value: %logdatefmtdelim% )
call :eocuhtotheline
(set outputpart1=Log stdoudea.txt Date format )
(set outputpart2=value: %logdatefmt% )
call :eocuhtotheline
(set outputpart1=List of stdoutdea.txt file to run )
(set outputpart2=value: %listoffiles% )
call :eocuhtotheline
(set outputpart1=Boinc data directory )
(set outputpart2=value: %boincdatadir% )
call :eocuhtotheline
(set outputpart1=Write report data to csv file )
(set outputpart2=value: %writelogdatatofilecsv% )
call :eocuhtotheline
(set outputpart1=Write report to text file )
(set outputpart2=value: %writelogdatatofilerpt% )
call :eocuhtotheline
(set outputpart1=Report Detail display and save to file )
(set outputpart2=value: %writereportdetail% )
call :eocuhtotheline
(set outputpart1=Report assigned work)
(set outputpart2=value: %writeassignedwork% )
call :eocuhtotheline
(set outputpart1=Report success failure percentage)
(set outputpart2=value: %writesuccessfailurepercentage% )
call :eocuhtotheline
(set outputpart1=Report %% of failure to all schedule failures)
(set outputpart2=value: %writepercentageofschedfailuretoallschedfailures% )
call :eocuhtotheline
(set outputpart1=Report %% of failure to all schdeule requests)
(set outputpart2=value: %writepercentageofschedfailuretoallschedrequests% )
call :eocuhtotheline
(set outputpart1=Report Totals display and save to file )
(set outputpart2=value: %writereporttotal% )
call :eocuhtotheline
(set outputpart1=File to write csv data to )
(set outputpart2=value: %logdatafilecsv% )
call :eocuhtotheline
(set outputpart1=File to write report lines to )
(set outputpart2=value: %logdatafilerpt% )
call :eocuhtotheline
(set outputpart1=Schedule success message )
(set outputpart2=value: %schedsuccess% )
call :eocuhtotheline
(set outputpart1=Schedule failure message )
(set outputpart2=value: %schedfailure% )
call :eocuhtotheline
for /L %%O in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%O (
(set outputpart1=Process schedule failure message)
(set outputpart2=value: !schedfailure%%O! )
call :eocuhtotheline
rem if defined schedfailure%%O (
)
rem for /L %%O in (1,1,%schedfailureitems%) DO (
)
(set outputpart1=Month 01 name abbrevation )
(set outputpart2=value: %mname01% )
call :eocuhtotheline
(set outputpart1=Month 02 name abbrevation )
(set outputpart2=value: %mname02% )
call :eocuhtotheline
(set outputpart1=Month 03 name abbrevation )
(set outputpart2=value: %mname03% )
call :eocuhtotheline
(set outputpart1=Month 04 name abbrevation )
(set outputpart2=value: %mname04% )
call :eocuhtotheline
(set outputpart1=Month 05 name abbrevation )
(set outputpart2=value: %mname05% )
call :eocuhtotheline
(set outputpart1=Month 06 name abbrevation )
(set outputpart2=value: %mname06% )
call :eocuhtotheline
(set outputpart1=Month 07 name abbrevation )
(set outputpart2=value: %mname07% )
call :eocuhtotheline
(set outputpart1=Month 08 name abbrevation )
(set outputpart2=value: %mname08% )
call :eocuhtotheline
(set outputpart1=Month 09 name abbrevation )
(set outputpart2=value: %mname09% )
call :eocuhtotheline
(set outputpart1=Month 10 name abbrevation )
(set outputpart2=value: %mname10% )
call :eocuhtotheline
(set outputpart1=Month 11 name abbrevation )
(set outputpart2=value: %mname11% )
call :eocuhtotheline
(set outputpart1=Month 12 name abbrevation )
(set outputpart2=value: %mname12% )
call :eocuhtotheline
@ECHO --- ---
rem goto :endthis
set errorset=no
set readstdoutdaefordates=no
if [%datetostrtwith%] NEQ [] (
if [%datetoendwith%] NEQ [] (
if %readstdoutdaefiles% EQU yes (
set readthrustdoutdae=no
if [%datetostrtwith%] EQU [file] (
if !readthrustdoutdae! EQU no (
@ECHO Procesing stdoutdae.txt file or filelist to get Date range start and/or end date.
@ECHO --- ---
set readthrustdoutdae=yes
rem if !readthrustdoutdae! EQU no (
)
call :readthrustdoutdaefile
@ECHO --- ---
set readstdoutdaefordates=yes
rem if [%datetostrtwith%] EQU [file] (
)
if [%datetoendwith%] EQU [file] (
if !readthrustdoutdae! EQU no (
@ECHO Procesing stdoutdae.txt file or filelist to get Date range start and/or end date.
@ECHO --- ---
set readthrustdoutdae=yes
rem if !readthrustdoutdae! EQU no (
)
call :readthrustdoutdaefile
@ECHO --- ---
set readstdoutdaefordates=yes
rem if [%datetoendwith%] EQU [file] (
)
rem if %readstdoutdaefiles% EQU yes (
)
if [%datetostrtwith%] EQU [file] call :getfiledate datetostrtwith datetoendwith
if [%datetoendwith%] EQU [file] call :getfiledate datetostrtwith datetoendwith
rem echo datetostrtwith pct=%datetostrtwith%=excl=!datetostrtwith!=end
rem echo datetoendwith pct=%datetoendwith%=excl=!datetoendwith!=end
if [%datetoendwith%] NEQ [file] (
call :datetimeforrun %datetoendwith%
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo %datetoendwith%') DO (
set datetoendwithchkpart1=%%F
set datetoendwithchkpart2=%%G
set datetoendwithchkpart3=%%H
)
rem if [%datetoendwith%] NEQ [file] (
)
if [%datetoendwith%] EQU [file] (
call :datetimeforrun !datetoendwith!
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo !datetoendwith!') DO (
set datetoendwithchkpart1=%%F
set datetoendwithchkpart2=%%G
set datetoendwithchkpart3=%%H
)
rem if [%datetoendwith%] EQU [file] (
)
rem echo dtddf pct=%dtddf%=excl=!dtddf!=end
set datetorunerror=no
set datetorunenderror=no
set datetoendwithdy=!dtddf!
(set datetoendwithdyerrormsg1=)
if !datetoendwithdy! GTR 31 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithdyerrormsg1=End date day is greater then it should be
rem if !datetoendwithdy! GTR 31 (
)
call :strlen datetoendwithdylength !datetoendwithdy!
(set datetoendwithdyerrormsg2=)
if !datetoendwithdylength! GTR 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithdyerrormsg2=To many digits in day value
rem if !datetoendwithdylength! GTR 2 (
)
(set datetoendwithdyerrormsg3=)
if !datetoendwithdylength! LSS 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithdyerrormsg3=To few digits in day value
rem if !datetoendwithdylength! LSS 2 (
)
rem echo dtmmf pct=%dtmmf%=excl=!dtmmf!=end
set datetoendwithmo=!dtmmf!
(set datetoendwithmoerrormsg1=)
if !datetoendwithmo! GTR 12 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithmoerrormsg1=End date month is greater then it should be
rem if !datetoendwithmo! GTR 12 (
)
call :strlen datetoendwithmolength !datetoendwithmo!
(set datetoendwithmoerrormsg2=)
if !datetoendwithmolength! GTR 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithmoerrormsg2=To many digits in month value
rem if !datetoendwithdylength! GTR 2 (
)
(set datetoendwithmoerrormsg3=)
if !datetoendwithmolength! LSS 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithmoerrormsg3=To few digits in month value
rem if !datetoendwithdylength! LSS 2 (
)
rem echo dtyrf pct=%dtyrf%=excl=!dtyrf!=end
set datetoendwithyr=!dtyrf!
call :strlen datetoendwithyrlength !datetoendwithyr!
(set datetoendwithyrerrormsg1=)
if !datetoendwithyrlength! LSS 4 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithyrerrormsg1=To reduce errors please use 4 digit year
rem if !datetoendwithyrlength! LSS 4 (
)
if [!pcdatepart1!] EQU [y] set datetoendwithchkyrpart=!datetoendwithchkpart1!
if [!pcdatepart2!] EQU [y] set datetoendwithchkyrpart=!datetoendwithchkpart2!
if [!pcdatepart3!] EQU [y] set datetoendwithchkyrpart=!datetoendwithchkpart3!
call :strlen datetoendwithyrlength !datetoendwithchkyrpart!
(set datetoendwithyrerrormsg1=)
if !datetoendwithyrlength! LSS 4 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithyrerrormsg1=To reduce errors please use 4 digit year
rem if !datetoendwithyrlength! LSS 4 (
)
if [%datetostrtwith%] NEQ [file] (
call :datetimeforrun %datetostrtwith%
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo %datetostrtwith%') DO (
set datetostrtwithchkpart1=%%F
set datetostrtwithchkpart2=%%G
set datetostrtwithchkpart3=%%H
)
rem if [%datetostrtwith%] NEQ [file] (
)
if [%datetostrtwith%] EQU [file] (
call :datetimeforrun !datetostrtwith!
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo !datetostrtwith!') DO (
set datetostrtwithchkpart1=%%F
set datetostrtwithchkpart2=%%G
set datetostrtwithchkpart3=%%H
)
rem if [%datetostrtwith%] EQU [file] (
)
set datetorunstrterror=no
set datetostrtwithdy=!dtddf!
(set datetostrtwithdyerrormsg1=)
if !datetostrtwithdy! GTR 31 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithdyerrormsg1=Start date day is greater then it should be
rem if !datetostrtwithdy! GTR 31 (
)
call :strlen datetostrtwithdylength !datetostrtwithdy!
(set datetostrtwithdyerrormsg2=)
if !datetostrtwithdylength! GTR 2 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithdyerrormsg2=To many digits in day value
rem if !datetostrtwithdylength! GTR 2 (
)
(set datetostrtwithdyerrormsg3=)
if !datetostrtwithdylength! LSS 2 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithdyerrormsg3=To few digits in day value
rem if !datetostrtwithdylength! LSS 2 (
)
set datetostrtwithmo=!dtmmf!
(set datetostrtwithmoerrormsg1=)
if !datetostrtwithmo! GTR 12 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithmoerrormsg1=Start date month is greater then it should be
rem if !datetostrtwithmo! GTR 12 (
)
call :strlen datetostrtwithmolength !datetostrtwithmo!
(set datetostrtwithmoerrormsg2=)
if !datetostrtwithmolength! GTR 2 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithmoerrormsg2=To many digits in month value
rem if !datetostrtwithdylength! GTR 2 (
)
(set datetostrtwithmoerrormsg3=)
if !datetostrtwithmolength! LSS 2 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithmoerrormsg3=To few digits in month value
rem if !datetostrtwithdylength! LSS 2 (
)
set datetostrtwithyr=!dtyrf!
call :strlen datetostrtwithyrlength !datetostrtwithyr!
(set datetostrtwithyrerrormsg1=)
if !datetostrtwithyrlength! LSS 4 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithyrerrormsg1=To reduce errors please use 4 digit year
rem if !datetostrtwithyrlength! LSS 4 (
)
if [!pcdatepart1!] EQU [y] set datestrtwithchkyrpart=!datetostrtwithchkpart1!
if [!pcdatepart2!] EQU [y] set datestrtwithchkyrpart=!datetostrtwithchkpart2!
if [!pcdatepart3!] EQU [y] set datestrtwithchkyrpart=!datetostrtwithchkpart3!
call :strlen datetostrtwithyrlength !datestrtwithchkyrpart!
(set datetostrtwithyrerrormsg1=)
if !datetostrtwithyrlength! LSS 4 (
set datetorunerror=yes
set datetorunstrterror=yes
set datetostrtwithyrerrormsg1=To reduce errors please use 4 digit year
rem if !datetostrtwithyrlength! LSS 4 (
)
if !datetorunerror! EQU no call :datemath !datetostrtwithyr! !datetostrtwithmo! !datetostrtwithdy! - !datetoendwithyr! !datetoendwithmo! !datetoendwithdy!
set /A check_days=!_dd_int!+1
rem if [%datetoendwith%] NEQ [] (
) else (
call :datetimeforrun
rem if [%datetoendwith%] NEQ [] ) else (
)
rem if [%datetostrtwith%] NEQ [] (
) else (
call :datetimeforrun
rem if [%datetostrtwith%] NEQ [] ) else (
)
set cdy=%dtddf%
set cmo=%dtmmf%
set cyr=%dtyrf%
set totstrtcdy=%dtddf%
set totstrtcmo=%dtmmf%
set totstrtcyr=%dtyrf%
if !datetorunstrterror! EQU yes (
if [%datetostrtwith%] NEQ [] @ECHO Start Date is in Error:
if [%datetostrtwith%] EQU [] @ECHO PC Date problem with format:
@ECHO.
@ECHO Based on this format: %pcdatefmt%
if [%datetostrtwith%] NEQ [] @ECHO This date:  %datetostrtwith% appears to be invalid.
@ECHO.
if defined datetostrtwithdyerrormsg1 @ECHO !datetostrtwithdyerrormsg1!
if defined datetostrtwithdyerrormsg2 @ECHO !datetostrtwithdyerrormsg2!
if defined datetostrtwithdyerrormsg3 @ECHO !datetostrtwithdyerrormsg3!
if defined datetostrtwithmoerrormsg1 @ECHO !datetostrtwithmoerrormsg1!
if defined datetostrtwithmoerrormsg2 @ECHO !datetostrtwithmoerrormsg2!
if defined datetostrtwithmoerrormsg3 @ECHO !datetostrtwithmoerrormsg3!
if defined datetostrtwithyrerrormsg1 @ECHO !datetostrtwithyrerrormsg1!
@ECHO.
if [%datetostrtwith%] NEQ [] @ECHO Edit the control.ini file to correct the start date value assigned to datetostrtwith or date format value assigned to pcdatefmt.
if [%datetostrtwith%] EQU [] (
if defined datetostrtwithyrerrormsg1 @ECHO Please change Windows settings to use date format with 4 digit year.
rem if [%datetostrtwith%] EQU [] (
)
@ECHO --- ---
if !datetorunenderror! NEQ yes goto :endthis
rem if !datetorunstrterror! EQU yes (
)
if !datetorunenderror! EQU yes (
if [%datetoendwith%] NEQ [] @ECHO End Date is in Error:
if [%datetoendwith%] EQU [] @ECHO PC Date problem with format:
@ECHO.
@ECHO Based on this format: %pcdatefmt%
if [%datetoendwith%] NEQ [] @ECHO This date:  %datetoendwith% appears to be invalid.
if [%datetoendwith%] EQU [] @ECHO This date:  !date! appears to be invalid.
@ECHO.
if defined datetoendwithdyerrormsg1 @ECHO !datetoendwithdyerrormsg1!
if defined datetoendwithdyerrormsg2 @ECHO !datetoendwithdyerrormsg2!
if defined datetoendwithdyerrormsg3 @ECHO !datetoendwithdyerrormsg3!
if defined datetoendwithmoerrormsg1 @ECHO !datetoendwithmoerrormsg1!
if defined datetoendwithmoerrormsg2 @ECHO !datetoendwithmoerrormsg2!
if defined datetoendwithmoerrormsg3 @ECHO !datetoendwithmoerrormsg3!
if defined datetoendwithyrerrormsg1 @ECHO !datetoendwithyrerrormsg1!
@ECHO.
if [%datetoendwith%] NEQ [] @ECHO Edit the control.ini file to correct the end date value assigned to datetoendwith or date format value assigned to pcdatefmt.
if [%datetoendwith%] EQU [] (
if defined datetoendwithyrerrormsg1 @ECHO Please change Windows settings to use date format with 4 digit year.
rem if [%datetoendwith%] EQU [] (
)
@ECHO --- ---
goto :endthis
rem if !datetorunenderror! EQU yes (
)
if [%datetoendwith%] GTR [%datetostrtwith%] (
@ECHO Processing date error
@ECHO End date is greater then Start date
@ECHO End date: %datetoendwith%
@ECHO Start date: %datetostrtwith%
@ECHO Exiting...
set errorset=yes
goto :endthis
rem if [%datetoendwith%] GTR [%datetostrtwith%] (
)
if [%datetostrtwith%] NEQ [] (
if [%datetoendwith%] NEQ [] (
if !datetorunerror! EQU no (
@ECHO Running in Date Range mode Start date: %datetostrtwith% End date: %datetoendwith%
@ECHO --- ---
rem if !datetorunenderror! EQU no (
)
rem if [%datetoendwith%] NEQ [] (
)
rem if [%datetostrtwith%] NEQ [] (
)
set edychk1=-
set /a lct=0
set /A schdreqcnttotal=0
set /A successtotal=0
set /A successassignedwucounttotal=0
set /A successassignedwutotal=0
set /A failstotal=0
set /A connect_failstotal=0
set /A peerdata_failstotal=0
set /A time_failstotal=0
set /A returnnothing_failstotal=0
set /A resolvehostname_failstotal=0
set /A httpinternalservererror_failstotal=0
set /A httpserviceunavailableerror_failstotal=0
set /A totalchk_failstotal=0
set /A unknownerror_failstotal=0
@ECHO Start date: %totstrtcyr%%pcdatefmtdelim%%totstrtcmo%%pcdatefmtdelim%%totstrtcdy% Going back %check_days% days
@ECHO Collecting schedule data on Boinc project: %logdataproject% for computer: %runforcomputer%
call :datemath %cyr% %cmo% %cdy%
rem echo %_yy_int% %_mm_str% %_dd_str%
call :datemathtologfmtorder
call :logdatefmt %datemathtologfmt%  matchlogdate
rem echo Log search date: %matchlogdate%
rem goto :endthis
if not exist "%boincdatadir%stdoutdae.txt" (
@ECHO "%boincdatadir%stdoutdae.txt" was not found
@ECHO exiting
goto :endthis
rem if exist "%boincdatadir%stdoutdae.txt" (
)
set fileprocesscnt=0
set writemode=^>
set runmissingfile=no
if %readstdoutdaefiles% EQU no (
@ECHO.
@ECHO Batch variable "readstdoutdaefiles" set to %readstdoutdaefiles%.
@ECHO Processing files Created during last run.
@ECHO.
if not exist "%failurefile%" (
@ECHO Needed file Missing:  "%failurefile%"
set runmissingfile=yes
rem if not exist "%failurefile%" (
)
if not exist "%successfile%" (
@ECHO Needed file Missing: "%successfile%"
set runmissingfile=yes
rem if not exist "%successfile%" (
)
if !runmissingfile! EQU yes @ECHO. & goto :endthis
rem if %readstdoutdaefiles% EQU no (
)
if %readstdoutdaefiles% EQU yes (
if %readstdoutdaefordates% EQU no (
call :readthrustdoutdaefile
rem if %readstdoutdaefordates% EQU no (
)
rem if %readstdoutdaefiles% EQU yes (
)
rem goto :endthis
set reportmode=day
:start
set /a lct=%lct%+1
findstr /C:"%matchlogdate%" "%failurefile%" >"%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"
if exist "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" (
for /L %%P in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%P (
findstr /R /C:"%matchlogdate%.*%schedfailure% !schedfailure%%P!" "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" >"%boincinfofileprefix%failures_schedfailure%%P-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"
rem if defined schedfailure%%P (
)
rem for /L %%P in (1,1,%schedfailureitems%) DO (
)
rem if exist "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" (
)
findstr /C:"%matchlogdate%" "%successfile%" >"%boincinfofileprefix%successes-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"
REM ---start output senction
set fails=0
if exist "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" for /f %%a in ('Find /V /C "" ^< "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"') do set fails=%%a
for /L %%Q in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%Q (
set schedfailure%%Q_fails=0
if exist "%boincinfofileprefix%failures_schedfailure%%Q-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" for /f %%a in ('Find /V /C "" ^< "%boincinfofileprefix%failures_schedfailure%%Q-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"') do set schedfailure%%Q_fails=%%a
rem if defined schedfailure%%Q (
)
rem for /L %%Q in (1,1,%schedfailureitems%) DO (
)
set success=0
if exist "%boincinfofileprefix%successes-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" for /f %%a in ('Find /V /C "" ^< "%boincinfofileprefix%successes-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"') do set success=%%a
set /a schdreqcnt=%fails%+%success%
call :outputreport
if %lct%==%check_days% (
set reportmode=totals
call :outputreport
if !writereportout! EQU yes (
%rptline%
if  %writelogdatatofilerpt% EQU yes %rptline% >>%logdatafilerpt%
rem if  !writereportout! EQU yes (
)
goto :endthis
rem if %lct%==%check_days% (
)
if %cdy:~0,1%==%edychk1% @ECHO Date makes no sense. I Can't math! & goto :endthis
call :datemath %cyr% %cmo% %cdy% - 1
call :datemathtologfmtorder
call :logdatefmt %datemathtologfmt%  matchlogdate
rem echo Log search date: %matchlogdate%
set cdy=%_dd_str%
set cyr=%_yy_int%
set cmo=%_mm_str%
if exist "%boincinfofileprefix%*-%runforcomputer%_*.txt" del "%boincinfofileprefix%*-%runforcomputer%_*.txt"
goto :start

:boincregistry
if [%subroutinemsg%] EQU [yes] @ECHO entering boincregistry
(set ValueName=)
(set ValueType=)
(set ValueValue=)
FOR /F "tokens=1-5" %%A IN ('REG QUERY "%key_name%" /v "%value_name%" 2^>nul') DO (
    set ValueName=%%A
    set ValueType=%%B
    set ValueValue=%%C
    if [%%D] NEQ [] (set ValueValue=%%C %%D)
    if [%%E] NEQ [] (set ValueValue=%%C %%D %%E)
)

if defined ValueName (
    rem @echo Value Name = %ValueName%
    rem @echo Value Type = %ValueType%
    rem @echo Value Value = %ValueValue%===
    set %1=%ValueValue%
) else (
    @ECHO Registry key:
    @ECHO %key_name%\%value_name% not found.
)
rem exit :boincregistry
exit /b

:norangedatecheck
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo !date!') DO (
set datenorwithchkpart1=%%F
set datenorwithchkpart2=%%G
set datenorwithchkpart3=%%H
)
if [!pcdatepart1!] EQU [d] set datenorwithchkdypart=!datenorwithchkpart1!
if [!pcdatepart2!] EQU [d] set datenorwithchkdypart=!datenorwithchkpart2!
if [!pcdatepart3!] EQU [d] set datenorwithchkdypart=!datenorwithchkpart3!
(set datetoendwithdyerrormsg1=)
if !datenorwithchkdypart! GTR 31 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithdyerrormsg1=End date day is greater then it should be
rem if !datenorwithchkdypart! GTR 31 (
)
call :strlen datetoendwithdylength !datenorwithchkdypart!
(set datetoendwithdyerrormsg2=)
if !datetoendwithdylength! GTR 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithdyerrormsg2=To many digits in day value
rem if !datetoendwithdylength! GTR 2 (
)
if [!pcdatepart1!] EQU [m] set datenorwithchkmopart=!datenorwithchkpart1!
if [!pcdatepart2!] EQU [m] set datenorwithchkmopart=!datenorwithchkpart2!
if [!pcdatepart3!] EQU [m] set datenorwithchkmopart=!datenorwithchkpart3!
(set datetoendwithmoerrormsg1=)
if !datenorwithchmopart! GTR 12 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithmoerrormsg1=End date month is greater then it should be
rem if !datenorwithchmopart! GTR 12 (
)
call :strlen datetoendwithmolength !datenorwithchmopart!
(set datetoendwithmoerrormsg2=)
if !datetoendwithmolength! GTR 2 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithmoerrormsg2=To many digits in month value
rem if !datetoendwithdylength! GTR 2 (
)
if [!pcdatepart1!] EQU [y] set datenorwithchkyrpart=!datenorwithchkpart1!
if [!pcdatepart2!] EQU [y] set datenorwithchkyrpart=!datenorwithchkpart2!
if [!pcdatepart3!] EQU [y] set datenorwithchkyrpart=!datenorwithchkpart3!
call :strlen datetoendwithyrlength !datetoendwithchkyrpart!
(set datetoendwithyrerrormsg1=)
if !datetoendwithyrlength! LSS 4 (
set datetorunerror=yes
set datetorunenderror=yes
set datetoendwithyrerrormsg1=To reduce errors please use 4 digit year
rem if !datetoendwithyrlength! LSS 4 (
)
rem exit :norangedatecheck
exit /b

:datetimeforrun
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo %pcdatefmt%') DO (
set pcdatepart1=%%F
set pcdatepart2=%%G
set pcdatepart3=%%H
)
FOR /F "tokens=1,2,3 delims=%logdatefmtdelim%" %%F IN ('echo %logdatefmt%') DO (
set logdatepart1=%%F
set logdatepart2=%%G
set logdatepart3=%%H
)
if [%1] NEQ [] set forrundate=%1
if [%1] EQU [] set forrundate=!date!
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%C IN ('echo !forrundate!') DO (
if [!pcdatepart1!] EQU [y] set dtyr=%%C
if [!pcdatepart2!] EQU [y] set dtyr=%%D
if [!pcdatepart3!] EQU [y] set dtyr=%%E
set dtyrzo=!dtyr:~0,1!
if !dtyrzo! EQU 0 set dtyr=!dtyr:~1,1!
set /A dtyrc=dtyr+20000
set dtyrfb=!dtyrc:~1!
set dtyrfzo1=!dtyrfb:~0,1!
if !dtyrfzo1! EQU 0 set dtyrf=!dtyrfb:~1!
set dtyrfzo2=!dtyrfb:~1,1!
if !dtyrfzo2! EQU 0 set dtyrf=!dtyrfb:~2!
set dtyrfzo3=!dtyrfb:~2,1!
if !dtyrfzo3! EQU 0 set dtyrf=!dtyrfb:~3!
if !dtyrfzo! EQU 0 set /A dtyrc=dtyrf+22000
if !dtyrfzo! EQU 0 set dtyrf=!dtyrc:~1!
if [!pcdatepart1!] EQU [m] set dtmm=%%C
if [!pcdatepart2!] EQU [m] set dtmm=%%D
if [!pcdatepart3!] EQU [m] set dtmm=%%E
set dtmmzo=!dtmm:~0,1!
if !dtmmzo! EQU 0 set dtmm=!dtmm:~1,1!
set /A dtmmc=dtmm+100
set dtmmf=!dtmmc:~1!
if [!pcdatepart1!] EQU [d] set dtdd=%%C
if [!pcdatepart2!] EQU [d] set dtdd=%%D
if [!pcdatepart3!] EQU [d] set dtdd=%%E
set dtddzo=!dtdd:~0,1!
if !dtddzo! EQU 0 set dtdd=!dtdd:~1,1!
set /A dtddc=dtdd+100
set dtddf=!dtddc:~1!
set outfndtdttemp=!dtyrf!!dtmmf!!dtddf!
)
FOR /F "tokens=1,2,3 delims=%pctimefmtdelim% " %%C IN ('echo !time!') DO (
set dthr=%%C
set /A dthr=dthr+100
set dthr=!dthr:~1!
set dtmin=%%D
set /A dtmin=dtmin+100
set dtmin=!dtmin:~1!
set dtss=%%E
set dtss=!dtss:.=_!
set outfndttmtemp=!dthr!!dtmin!!dtss!
)
rem exit :datetimeforrun
exit /b

:datemathtologfmtorder
if [%logdatepart1%] EQU [d] set datemathtologfmt=%_dd_str%%logdatefmtdelim%
if [%logdatepart1%] EQU [m] set datemathtologfmt=%_mm_str%%logdatefmtdelim%
if [%logdatepart1%] EQU [3cm] set datemathtologfmt=%_mm_str%%logdatefmtdelim%
if [%logdatepart1%] EQU [y] set datemathtologfmt=%_yy_int%%logdatefmtdelim%
if [%logdatepart2%] EQU [d] set datemathtologfmt=%datemathtologfmt%%_dd_str%%logdatefmtdelim%
if [%logdatepart2%] EQU [m] set datemathtologfmt=%datemathtologfmt%%_mm_str%%logdatefmtdelim%
if [%logdatepart2%] EQU [3cm] set datemathtologfmt=%datemathtologfmt%%_mm_str%%logdatefmtdelim%
if [%logdatepart2%] EQU [y] set datemathtologfmt=%datemathtologfmt%%_yy_int%%logdatefmtdelim%
if [%logdatepart3%] EQU [d] set datemathtologfmt=%datemathtologfmt%%_dd_str%
if [%logdatepart3%] EQU [m] set datemathtologfmt=%datemathtologfmt%%_mm_str%
if [%logdatepart3%] EQU [3cm] set datemathtologfmt=%datemathtologfmt%%_mm_str%
if [%logdatepart3%] EQU [y] set datemathtologfmt=%datemathtologfmt%%_yy_int%
rem exit :datemathtologfmtorder
exit /b

:logdatefmt
FOR /F "tokens=1,2,3 delims=%logdatefmtdelim%" %%C IN ('echo %1') DO (
if [!logdatepart1!] EQU [y] set dtyr=%%C
if [!logdatepart2!] EQU [y] set dtyr=%%D
if [!logdatepart3!] EQU [y] set dtyr=%%E
set dtyrzo=!dtyr:~0,1!
if !dtyrzo! EQU 0 set dtyr=!dtyr:~1,1!
set /A dtyrc=dtyr+20000
set dtyrfb=!dtyrc:~1!
set dtyrfzo1=!dtyrfb:~0,1!
if !dtyrfzo1! EQU 0 set dtyrf=!dtyrfb:~1!
set dtyrfzo2=!dtyrfb:~1,1!
if !dtyrfzo2! EQU 0 set dtyrf=!dtyrfb:~2!
set dtyrfzo3=!dtyrfb:~2,1!
if !dtyrfzo3! EQU 0 set dtyrf=!dtyrfb:~3!
if !dtyrfzo! EQU 0 set /A dtyrc=dtyrf+22000
if !dtyrfzo! EQU 0 set dtyrf=!dtyrc:~1!
if [!logdatepart1!] EQU [m] set dtmm=%%C
if [!logdatepart2!] EQU [m] set dtmm=%%D
if [!logdatepart3!] EQU [m] set dtmm=%%E
set dtmmzo=!dtmm:~0,1!
if !dtmmzo! EQU 0 set dtmm=!dtmm:~1,1!
set /A dtmmc=dtmm+100
set dtmmf=!dtmmc:~1!
if [!logdatepart1!] EQU [3cm] (
set dtmm=%%C
call :getmonthabbrev !dtmm!  dtmmf
rem if [!logdatepart1!] EQU [3cm] (
)
if [!logdatepart2!] EQU [3cm] (
set dtmm=%%D
call :getmonthabbrev !dtmm! dtmmf
rem if [!logdatepart2!] EQU [3cm] (
)
if [!logdatepart3!] EQU [3cm] (
set dtmm=%%E
call :getmonthabbrev !dtmm! dtmmf
rem if [!logdatepart3!] EQU [3cm] (
)
if [!logdatepart1!] EQU [d] set dtdd=%%C
if [!logdatepart2!] EQU [d] set dtdd=%%D
if [!logdatepart3!] EQU [d] set dtdd=%%E
set dtddzo=!dtdd:~0,1!
if !dtddzo! EQU 0 set dtdd=!dtdd:~1,1!
set /A dtddc=dtdd+100
set dtddf=!dtddc:~1!
set dtdt=!dtyrf!!dtmmf!!dtddf!
)
if [%logdatepart1%] EQU [d] set logdatefmtout=%dtddf%%logdatefmtdelim%
if [%logdatepart1%] EQU [m] set logdatefmtout=%dtmmf%%logdatefmtdelim%
if [%logdatepart1%] EQU [3cm] set logdatefmtout=%dtmmf%%logdatefmtdelim%
if [%logdatepart1%] EQU [y] set logdatefmtout=%dtyrf%%logdatefmtdelim%
if [%logdatepart2%] EQU [d] set logdatefmtout=%logdatefmtout%%dtddf%%logdatefmtdelim%
if [%logdatepart2%] EQU [m] set logdatefmtout=%logdatefmtout%%dtmmf%%logdatefmtdelim%
if [%logdatepart2%] EQU [3cm] set logdatefmtout=%logdatefmtout%%dtmmf%%logdatefmtdelim%
if [%logdatepart2%] EQU [y] set logdatefmtout=%logdatefmtout%%dtyrf%%logdatefmtdelim%
if [%logdatepart3%] EQU [d] set logdatefmtout=%logdatefmtout%%dtddf%
if [%logdatepart3%] EQU [m] set logdatefmtout=%logdatefmtout%%dtmmf%
if [%logdatepart3%] EQU [3cm] set logdatefmtout=%logdatefmtout%%dtmmf%
if [%logdatepart3%] EQU [y] set logdatefmtout=%logdatefmtout%%dtyrf%
set %2=%logdatefmtout%
rem exit :logdatefmt
exit /b

:getmonthabbrev
set sdtmm=%1
rem echo mname %sdtmm%: !mname%sdtmm%!
set %2=!mname%sdtmm%!
rem exit :getmonthabbrev
exit /b

:readthrustdoutdaefile
if exist "%listoffiles%" (
for /F %%R in ('type "%listoffiles%"') DO (
set processfilename=%%R
set filewasprocessed=no
if exist "!processfilename!" (
set /A fileprocesscnt=fileprocesscnt+1
if !fileprocesscnt! EQU 1 set writemode=^>
if !fileprocesscnt! GTR 1 set writemode=^>^>
call :processfile
set filewasprocessed=yes
rem if exist "!processfilename!" (
)
set fromlistfilename=deleteme.txt
if exist "%boincdatadir%!processfilename!" (
if !processfilename! EQU stdoutdae.txt (
echo Processing log file: "%boincdatadir%!processfilename!"
echo Coping data in log file to ".\!cmdfilename!-!processfilename!"
copy /Y "%boincdatadir%!processfilename!" ".\!cmdfilename!-!processfilename!" 1>NUL
set fromlistfilename=!processfilename!
set processfilename=.\!cmdfilename!-!processfilename!
rem if !processfilename! EQU stdoutdae.txt (
) else (
set processfilename=%boincdatadir%!processfilename!
rem if !processfilename! EQU stdoutdae.txt ) else (
)
set /A fileprocesscnt=fileprocesscnt+1
if !fileprocesscnt! EQU 1 set writemode=^>
if !fileprocesscnt! GTR 1 set writemode=^>^>
call :processfile
set filewasprocessed=yes
rem if exist "%boincdatadir%!processfilename!"
)
if !filewasprocessed! EQU no (
(set skipstatus=)
if exist "!processfilename!" (
rem if exist "!processfilename!" (
) else (
set skipstatus=- File Missing
rem if exist "!processfilename!" ) else (
)
@ECHO Processing file was Skipped: !processfilename! !skipstatus!
rem if !filewasprocessed! EQU no (
)
rem for /F %%R in ('type "%listoffiles%"') DO (
)
rem if exist "%listoffiles%" (
) else (
set processfilename=%boincdatadir%stdoutdae.txt
echo Processing log file: "%boincdatadir%!stdoutdae.txt"
set fromlistfilename=stdoutdae.txt
echo Coping data in log file to ".\!cmdfilename!-stdoutdae.txt"
copy /Y "%boincdatadir%stdoutdae.txt" ".\!cmdfilename!-stdoutdae.txt" 1>NUL
set processfilename=.\!cmdfilename!-stdoutdae.txt
call :processfile
rem if exist "%listoffiles%" ) else (
)
if exist ".\%cmdfilename%-%fromlistfilename%" del ".\%cmdfilename%-%fromlistfilename%"
rem exit :readthrustdoutdaefile
exit /b

:getfiledate
FOR /F "tokens=1,2,3 delims=%pcdatefmtdelim%" %%F IN ('echo %pcdatefmt%') DO (
set pcdatepart1=%%F
set pcdatepart2=%%G
set pcdatepart3=%%H
)
FOR /F "tokens=1,2,3 delims=%logdatefmtdelim%" %%F IN ('echo %logdatefmt%') DO (
set logdatepart1=%%F
set logdatepart2=%%G
set logdatepart3=%%H
)
set /A rcnt=0
FOR /F "tokens=1,2*" %%D IN ('type %successfile%') DO (
rem echo rcnt pct=%rcnt%=excl=!rcnt!=end
set /A rcnt=rcnt+1
if !rcnt! EQU 1 (
set dateendsuccess=%%D
rem if !rcnt! EQU 1 (
)
set datestrtsuccess=%%D
rem FOR /F "tokens=1,2*" %%D IN ('type %successfile%') DO (
)
if %datetostrtwith% EQU file (
call :filedatetopcdate  datestrtsuccesspcfmt %datestrtsuccess%
@ECHO Success file start date: %datestrtsuccess% in PC date format: !datestrtsuccesspcfmt!
rem if %datetostrtwith% EQU file (
)
if %datetoendwith% EQU file (
call :filedatetopcdate  dateendsuccesspcfmt %dateendsuccess%
@ECHO Success file end date: %dateendsuccess% in PC date format: !dateendsuccesspcfmt!
rem if %datetoendwith% EQU file (
)
set /A rcnt=0
FOR /F "tokens=1,2*" %%D IN ('type %failurefile%') DO (
set /A rcnt=rcnt+1
if !rcnt! EQU 1 (
set dateendfailure=%%D
rem if !rcnt! EQU 1 (
)
set datestrtfailure=%%D
rem FOR /F "tokens=1,2*" %%D IN ('type %df%') DO (
)
if %datetostrtwith% EQU file (
call :filedatetopcdate  datestrtfailurepcfmt %datestrtfailure%
@ECHO Failure file start date: %datestrtfailure% in PC date format: !datestrtfailurepcfmt!
rem if %datetostrtwith% EQU file (
)
if %datetoendwith% EQU file (
call :filedatetopcdate  dateendfailurepcfmt %dateendfailure%
@ECHO Failure file end date: %dateendfailure% in PC date format: !dateendfailurepcfmt!
rem if %datetoendwith% EQU file (
)
if %datetostrtwith% NEQ file (
set datestrtsuccesspcfmt=%datetostrtwith%
set datestrtfailurepcfmt=%datetostrtwith%
rem if %datetostrtwith% NEQ file
)
if %datetoendwith% NEQ file (
set dateendsuccesspcfmt=%datetoendwith%
set dateendfailurepcfmt=%datetoendwith%
rem if %datetoendwith% NEQ file ) else (
)
if %datetostrtwith% NEQ file set getdatetostrtwith=%datetostrtwith%
if %datetostrtwith% EQU file (
if %datestrtsuccesspcfmt% GTR %datestrtfailurepcfmt% (
set getdatetostrtwith=%datestrtsuccesspcfmt%
rem if %datestrtsuccesspcfmt% GTR %datestrtfailurepcfmt% (
) else (
set getdatetostrtwith=%datestrtfailurepcfmt%
rem if %datestrtsuccesspcfmt% GTR %datestrtfailurepcfmt% ) else (
)
rem if %datetostrtwith% EQU file (
)
if %datetoendwith% NEQ file set getdatetoendwith=%datetoendwith%
if %datetoendwith% EQU file (
if %dateendsuccesspcfmt% GTR %dateendfailurepcfmt% (
set getdatetoendwith=%dateendfailurepcfmt%
rem if %dateendsuccesspcfmt% GTR %dateendfailurepcfmt% (
) else (
set getdatetoendwith=%dateendsuccesspcfmt%
rem if %dateendsuccesspcfmt% GTR %dateendfailurepcfmt% ) else (
)
rem if %datetoendwith% EQU file (
)
echo Going to run with start range date: %getdatetostrtwith%
echo Going to run with end range date: %getdatetoendwith%
set %1=%getdatetostrtwith%
set %2=%getdatetoendwith%
rem exit :getfiledate
exit /b

:filedatetopcdate
set filedate=%2
FOR /F "tokens=1,2,3 delims=%logdatefmtdelim%" %%F IN ('echo %filedate%') DO (
set filedatepart1=%%F
set filedatepart2=%%G
set filedatepart3=%%H
)
if [!logdatepart1!] EQU [y] set fdtyr=%filedatepart1%
if [!logdatepart2!] EQU [y] set fdtyr=%filedatepart2%
if [!logdatepart3!] EQU [y] set fdtyr=%filedatepart3%
if [!pcdatepart1!] EQU [y] set logfdtyr=%fdtyr%
if [!pcdatepart2!] EQU [y] set logfdtyr=%fdtyr%
if [!pcdatepart3!] EQU [y] set logfdtyr=%fdtyr%
if [!logdatepart1!] EQU [m] set fdtmm=%filedatepart1%
if [!logdatepart2!] EQU [m] set fdtmm=%filedatepart2%
if [!logdatepart3!] EQU [m] set fdtmm=%filedatepart3%
if [!logdatepart1!] EQU [3cm] call :textmonthabbrevtonum fdtmm %filedatepart1%
if [!logdatepart2!] EQU [3cm] call :textmonthabbrevtonum fdtmm %filedatepart2%
if [!logdatepart3!] EQU [3cm] call :textmonthabbrevtonum fdtmm %filedatepart3%
if [!pcdatepart1!] EQU [m] set logfdtmm=%fdtmm%
if [!pcdatepart2!] EQU [m] set logfdtmm=%fdtmm%
if [!pcdatepart3!] EQU [m] set logfdtmm=%fdtmm%
if [!pcdatepart1!] EQU [3cm] set logfdtmm=%fdtmm%
if [!pcdatepart2!] EQU [3cm] set logfdtmm=%fdtmm%
if [!pcdatepart3!] EQU [3cm] set logfdtmm=%fdtmm%
if [!logdatepart1!] EQU [d] set fdtdd=%filedatepart1%
if [!logdatepart2!] EQU [d] set fdtdd=%filedatepart2%
if [!logdatepart3!] EQU [d] set fdtdd=%filedatepart3%
if [!pcdatepart1!] EQU [d] set logfdtdd=%fdtdd%
if [!pcdatepart2!] EQU [d] set logfdtdd=%fdtdd%
if [!pcdatepart3!] EQU [d] set logfdtdd=%fdtdd%
call :logfiledatetopcfmtorder
set %1=%logfiledatetopcfmt%
rem exit :filedatetopcdate
exit /b

:textmonthabbrevtonum
set textmth=%2
for /L %%S in (1,1,12) DO (
set /A mmnum=100+%%S
set mmnumfmt=!mmnum:~1,2!
if defined mname!mmnumfmt! (
call set chkmthnm=%%mname!mmnumfmt!%%
if !chkmthnm! EQU !textmth! set %1=!mmnumfmt!
rem if defined mname!mmnumfmt! (
)
rem for /L %%S in (1,1,12) DO (
)
rem exit :textmonthabbrevtonum
exit /b

:logfiledatetopcfmtorder
if [%pcdatepart1%] EQU [d] set logfiledatetopcfmt=%logfdtdd%%pcdatefmtdelim%
if [%pcdatepart1%] EQU [m] set logfiledatetopcfmt=%logfdtmm%%pcdatefmtdelim%
if [%pcdatepart1%] EQU [3cm] set logfiledatetopcfmt=%logfdtmm%%pcdatefmtdelim%
if [%pcdatepart1%] EQU [y] set logfiledatetopcfmt=%logfdtyr%%pcdatefmtdelim%
if [%pcdatepart2%] EQU [d] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtdd%%pcdatefmtdelim%
if [%pcdatepart2%] EQU [m] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtmm%%pcdatefmtdelim%
if [%pcdatepart2%] EQU [3cm] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtmm%%pcdatefmtdelim%
if [%pcdatepart2%] EQU [y] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtyr%%pcdatefmtdelim%
if [%pcdatepart3%] EQU [d] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtdd%
if [%pcdatepart3%] EQU [m] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtmm%
if [%pcdatepart3%] EQU [3cm] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtmm%
if [%pcdatepart3%] EQU [y] set logfiledatetopcfmt=%logfiledatetopcfmt%%logfdtyr%
rem exit :logfiledatetopcfmtorder
exit /b

:processfile
@ECHO Processing file: %processfilename%
findstr /C:"%logdataproject% %schedfailure%" "%processfilename%" %writemode%"%failurefile%"
findstr /C:"%logdataproject% %schedsuccess% " "%processfilename%" %writemode%"%successfile%"
rem exit :processfile
exit /b

:outputreport
set writereportout=no
if %reportmode% EQU day (
if %writereportdetail% EQU yes set writereportout=yes
rem if %reportmode% EQU day (
)
if %reportmode% EQU totals (
if %writereporttotal% EQU yes set writereportout=yes
rem if %reportmode% EQU totals (
)
set rptline=@ECHO --- ---
call :outputtheline
set rptline=@ECHO Results for calendar date: %cyr%%logdatefmtdelim%%cmo%%logdatefmtdelim%%cdy% Log date: %matchlogdate%
if %reportmode% EQU totals set rptline=@ECHO Results Totals for calendar Start date: %totstrtcyr%%logdatefmtdelim%%totstrtcmo%%logdatefmtdelim%%totstrtcdy% End date: %cyr%%logdatefmtdelim%%cmo%%logdatefmtdelim%%cdy%
call :outputtheline
set rptline=@ECHO Run for Computer: %runforcomputer%
call :outputtheline
set rptline=@ECHO Scheduler:
call :outputtheline
set outputpart1=Requests
(set outputpart2extra=)
call :formatreportline nopct %schdreqcnt% 0 %schdreqcnttotal% 0 schdreqcnttotal pctplaceholder
call :outputtheline
set outputpart1=Successes
(set outputpart2extra=)
call :formatreportline nopct %success% 0 %successtotal% 0 successtotal pctplaceholder
call :outputtheline
set outputpart1=Failures
(set outputpart2extra=)
call :formatreportline nopct %fails% 0 %failstotal% 0 failstotal pctplaceholder
call :outputtheline
if [%writeassignedwork%] EQU [yes] (
set rptline=@ECHO.
call :outputtheline
set successassignedwu=0
set successassignedwucount=0
if %reportmode% EQU day (
for /F "tokens=*" %%R in ('type "%boincinfofileprefix%successes-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"') do (
(set texttosearch=%%R)
(set texttosearchtextfor=completed:)
call :getvaluefromtextsosearch successwuassigned "!texttosearch!" "!texttosearchtextfor!" 2
if !successwuassigned! GTR 0 (
set /A successassignedwucount=successassignedwucount+1
rem if successwuassigned GTR 0 (
)
set /A successassignedwu=successassignedwu+!successwuassigned!
rem for /F "tokens=*" %%R in ('type "%boincinfofileprefix%successes-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"') do (
)
rem if %reportmode% EQU day (
)
set outputpart1=Successes that assigned work
(set outputpart2extra=)
call :formatreportline nopct !successassignedwucount! 0 %successassignedwucounttotal% 0 successassignedwucounttotal pctplaceholder
call :outputtheline
set outputpart1=Count of work assigned by successes
(set outputpart2extra=)
call :formatreportline nopct !successassignedwu! 0 %successassignedwutotal% 0 successassignedwutotal pctplaceholder
call :outputtheline
rem if [%writeassignedwork%] EQU [yes] (
)
set rptline=@ECHO.
call :outputtheline
set rptline=@ECHO Failures breakdown:
call :outputtheline
for /L %%R in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%R (
set outputpart1=!schedfailure%%R!
(set outputpart2extra=)
if not defined schedfailure%%R_failstotal set schedfailure%%R_failstotal=0
call :formatreportline nopct !schedfailure%%R_fails! 0 !schedfailure%%R_failstotal! 0 schedfailure%%R_failstotal pctplaceholder
call :outputtheline
rem if defined schedfailure%%R (
)
rem for /L %%R in (1,1,%schedfailureitems%) DO (
)
set /A unknownerror_fails=0
set /A totalchk_fails=0
for /L %%U in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%U_fails (
set /A totalchk_fails=totalchk_fails+!schedfailure%%U_fails!
rem if defined schedfailure%%U_fails (
)
rem for /L %%U in (1,1,%schedfailureitems%) DO (
)
rem set /A totalchk_fails=connect_fails+peerdata_fails+time_fails+returnnothing_fails+resolvehostname_fails+httpinternalservererror_fails+httpserviceunavailableerror_fails
set /A unknownerror_fails=fails-totalchk_fails
if !unknownerror_fails! GTR 0 (
if %saveschedunknownfiles% EQU yes copy "%boincinfofileprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt" "%boincinfofileunknownprefix%failures-%runforcomputer%_%cyr%-%cmo%-%cdy%.txt"
rem if !unknownerror_fails! GTR 0 (
)
set outputpart1=Unknown category failure
(set outputpart2extra=)
call :formatreportline nopct %unknownerror_fails% 0 %unknownerror_failstotal% 0 unknownerror_failstotal pctplaceholder
call :outputtheline
if [%writesuccessfailurepercentage%] EQU [yes] (
set rptline=@ECHO.
call :outputtheline
rem percentages
set schdsuccesspct=0.00
set outputpart1=Success
set "outputpart2extra= %%"
call :formatreportline pct %success% %schdreqcnt% %successtotal% %schdreqcnttotal% totalplaceholder schdsuccesspct
call :outputtheline
set schdfailspct=0.00
set outputpart1=Failure
set "outputpart2extra= %%"
call :formatreportline pct %fails% %schdreqcnt% %failstotal% %schdreqcnttotal% totalplaceholder schdfailspct
call :outputtheline
rem if [%writesuccessfailurepercentage%] EQU [yes] (
)
if [%writepercentageofschedfailuretoallschedfailures%] EQU [yes] (
set rptline=@ECHO.
call :outputtheline
set rptline=@ECHO Failure %% to all schedule failures:
call :outputtheline
for /L %%S in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%S (
set schdcnfailspct=0.00
set outputpart1=!schedfailure%%S!
set "outputpart2extra= %% of failures"
call :formatreportline pct !schedfailure%%S_fails! %fails% !schedfailure%%S_failstotal! %failstotal% totalplaceholder schdcnfailspct
call :outputtheline
rem if defined schedfailure%%S (
)
rem for /L %%S in (1,1,%schedfailureitems%) DO (
)
set schduknfailspct=0.00
set outputpart1=Unknown category failure
set "outputpart2extra= %% of failures"
call :formatreportline pct %unknownerror_fails% %fails% %unknownerror_failstotal% %failstotal% totalplaceholder schduknfailspct
call :outputtheline
rem if [%writepercentageofschedfailuretoallschedfailures%] EQU [yes] (
)
if [%writepercentageofschedfailuretoallschedrequests%] EQU [yes] (
set rptline=@ECHO.
call :outputtheline
set rptline=@ECHO Failure %% to all schedule requests:
call :outputtheline
for /L %%T in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%T (
set schdcnfailspct=0.00
set outputpart1=!schedfailure%%T!
set "outputpart2extra= %% of total requests"
call :formatreportline pct !schedfailure%%T_fails! %schdreqcnt% !schedfailure%%T_failstotal! %schdreqcnttotal% totalplaceholder  schdcntofailspct
call :outputtheline
rem if defined schedfailure%%T (
)
rem for /L %%T in (1,1,%schedfailureitems%) DO (
)
set schdukntofailspct=0.00
set outputpart1=Unknown category failure
set "outputpart2extra= %% of total requests"
call :formatreportline pct %unknownerror_fails% %schdreqcnt% %unknownerror_failstotal% %schdreqcnttotal% totalplaceholder schdukntofailspct
call :outputtheline
rem if [%writepercentageofschedfailuretoallschedrequests%] EQU [yes] (
)
if %reportmode% NEQ totals (
if  %writelogdatatofilecsv% EQU yes (
if %lct% EQU 1 (
set csvline=matched log date,run for computer,schedule request count,success count,fails count,successes that assigned work,count of work assigned by successes
rem ,connect fail count,peer data fail count,timeout fail count,return nothing fail count,resolve host name fail count,http internal server error fail count,http service unavailable error fail count
for /L %%D in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%D (
set csvlinedesc=!schedfailure%%D!
set csvlinedesc=!csvlinedesc:,=!
set csvline=!csvline!,!csvlinedesc!
rem if defined schedfailure%%D (
)
rem for /L %%C in (1,1,%schedfailureitems%) DO (
)
@ECHO !csvline!,unknown error fail count>>%logdatafilecsv%
rem if %lct% EQU 1 (
)
set csvlinedata=%matchlogdate%,%runforcomputer%,%schdreqcnt%,%success%,%fails%,%successassignedwucount%,%successassignedwu%
rem %connect_fails%,%peerdata_fails%,%time_fails%,%returnnothing_fails%,%resolvehostname_fails%,%httpinternalservererror_fails%,%httpserviceunavailableerror_fails%
for /L %%D in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%D (
set csvlinedataitem=!schedfailure%%D_fails!
set csvlinedata=!csvlinedata!,!csvlinedataitem!
rem if defined schedfailure%%D (
)
rem for /L %%D in (1,1,%schedfailureitems%) DO (
)
@ECHO !csvlinedata!,^%unknownerror_fails%>>%logdatafilecsv%
rem if  %writelogdatatofilecsv% EQU yes (
)
rem if %writereportdetail% NEQ yes (
rem if  %writelogdatatofilecsv% EQU yes (
rem if %lct% EQU 1 @ECHO matched log date,run for computer,schedule request count,success count,fails count,successes that assigned work,count of work assigned by successes,connect fail count,peer data fail count,timeout fail count,return nothing fail count,resolve host name fail count,http internal server error fail count,http service unavailable error fail count,unknown error fail count>> %logdatafilecsv%
rem if  %writelogdatatofilecsv% EQU yes (
rem )
rem if %writereportdetail% NEQ yes (
rem )
rem if %reportmode% NEQ NEQ totals (
)
if %reportmode% EQU totals (
if  %writelogdatatofilecsv% EQU yes (
set csvlinedatatot=Totals,%runforcomputer%,%schdreqcnttotal%,%successtotal%,%failstotal%,%successassignedwucounttotal%,%successassignedwutotal%
rem ,%connect_failstotal%,%peerdata_failstotal%,%time_failstotal%,%returnnothing_failstotal%,%resolvehostname_failstotal%,%httpinternalservererror_failstotal%,%httpserviceunavailableerror_failstotal%
for /L %%E in (1,1,%schedfailureitems%) DO (
if defined schedfailure%%E (
set csvlinedatatotitem=!schedfailure%%E_failstotal!
set csvlinedatatot=!csvlinedatatot!,!csvlinedatatotitem!
rem if defined schedfailure%%E (
)
rem for /L %%E in (1,1,%schedfailureitems%) DO (
)
@ECHO !csvlinedatatot!,^%unknownerror_failstotal%>>%logdatafilecsv%
rem if  %writelogdatatofilecsv% EQU yes (
)
rem if %reportmode% EQU totals (
)
if [%pauseforextractfilereview%] EQU [yes] (
@ECHO Pausing to allow extract file review.
@ECHO Press any letter or number key on keyboard to continue
pause
rem if [%pauseforextractfilereview%] EQU [yes] (
)
set rptline=@ECHO --- ---
rem exit :outputreport
REM ---end output section
exit /b

:formatreportline
set fmtrpttype=%1
set fmtrptcnt=%2
set fmtrptdivcnt=%3
set fmtrptcnttotal=%4
set fmtrptdivcnttotal=%5
if [!fmtrpttype!] EQU [nopctxx] (
echo fmtrpttype=pct=%fmtrpttype%=excl=!fmtrpttype!=end
echo fmtrptcnt=pct=%fmtrptcnt%=excl=!fmtrptcnt!=end
echo fmtrptdivcnt=pct=%fmtrptdivcnt%=excl=!fmtrptdivcnt!=end
echo fmtrptcnttotal=pct=%fmtrptcnttotal%=excl=!fmtrptcnttotal!=end
echo fmtrptdivcnttotal=pct=%fmtrptdivcnttotal%=excl=!fmtrptdivcnttotal!=end
rem if [!fmtrpttype!] EQU [nopct] (
)
if %fmtrpttype% EQU nopct (
if %reportmode% NEQ totals (
set /A fmtrptcnttotal=fmtrptcnttotal+fmtrptcnt
set outvaluepart1=:
set outvaluepart2=%fmtrptcnt%
call :formatvalueoutput fmtrptcntfmt
rem if %reportmode% NEQ totals (
)
if %reportmode% EQU totals (
set outvaluepart1=:
set outvaluepart2=%fmtrptcnttotal%
call :formatvalueoutput fmtrptcntfmt
rem if %reportmode% EQU totals (
)
set outputpart2=!fmtrptcntfmt!
set %6=!fmtrptcnttotal!
rem if %fmtrpttype% EQU nopct (
)
if %fmtrpttype% EQU pct (
call :callcalcvaluepct %fmtrptcnt% %fmtrptdivcnt% %fmtrptcnttotal% %fmtrptdivcnttotal% fmtrptpct
set outvaluepart1=:
set outvaluepart2=!fmtrptpct!
call :formatvalueoutput fmtrptpctfmt
set outputpart2=!fmtrptpctfmt!%outputpart2extra%
set %7=!fmtrptpctfmt!
rem if %fmtrpttype% EQU pct (
)
call :eocuhtothelineformat rptline
set rptline=@ECHO %rptline%
rem exit :formatreportline
exit /b

:callcalcvaluepct
set pctcnt=%1
set pctdivcnt=%2
set pctcnttotal=%3
set pctdivcnttotal=%4
rem echo pctcnt=pct=%pctcnt%=excl=!pctcnt!=end
rem echo pctdivcnt=pct=%pctdivcnt%=excl=!pctdivcnt!=end
rem echo pctcnttotal=pct=%pctcnttotal%=excl=!pctcnttotal!=end
rem echo pctdivcnttotal=pct=%pctdivcnttotal%=excl=!pctdivcnttotal!=end
if %reportmode% NEQ totals (
if %pctdivcnt% GTR 0 (
call :calcvaluepct %pctcnt% %pctdivcnt% pctcalcd
set %5=!pctcalcd!
rem if %pctdivcnt% GTR 0 (
) else (
set %5=0.00
rem if %pctdivcnt% GTR 0 ) else (
)
rem if %reportmode% NEQ totals (
)
if %reportmode% EQU totals (
if %pctdivcnttotal% GTR 0 (
call :calcvaluepct %pctcnttotal% %pctdivcnttotal% pctcalcd
set %5=!pctcalcd!
rem if %pctdivcnt% GTR 0 (
) else (
set %5=0.00
rem if %pctdivcnttotal% GTR 0 ) else (
)
rem if %reportmode% EQU totals (
)
rem exit :callcalcvaluepct
exit /b

:outputtheline
if !writereportout! EQU yes (
call :writereportline
rem if  !writereportout! EQU yes (
)
rem exit :outputtheline
exit /b

:writereportline
%rptline%
if  %writelogdatatofilerpt% EQU yes %rptline% >>%logdatafilerpt%
rem exit :writereportline
exit /b

:calcvaluepct
set cvdi=%1
set cvdb=%2
set /a calcpctp1=%cvdi%*100000
set /a calcpct=!calcpctp1!/%cvdb%
rem echo calcpct 1excl=!calcpct!=pct=%calcpct%=end
set /a calcpct=!calcpct!+1000000
rem echo calcpct 2 excl=!calcpct!=pct=%calcpct%=end
set cvo1=!calcpct:~1,3!
if !cvo1:~0^,1! EQU 0 set cvo1=!cvo1:~1!
if !cvo1:~0^,1! EQU 0 set cvo1=!cvo1:~1!
set cvo2=!calcpct:~4!
rem echo cvo2 excl=!cvo2!=pc=%cvo2%=end
if !cvo2:~2^,1! GTR 4 (
if !cvo2:~0^,1! EQU 0 set cvo2=!cvo2:~1!
if !cvo2:~0^,1! EQU 0 set cvo2=!cvo2:~1!
set /A cvo2=!cvo2!+1010
rem echo cvo2 in gtr4 1 excl=!cvo2!=pc=%cvo2%=end
set cvo2=!cvo2:~1,2!
rem echo cvo2 in gtr4 2 excl=!cvo2!=pc=%cvo2%=end
rem if !cvo2:~2^,1! GTR 4 (
)
set cvo2=%cvo2:~0,2%
rem echo cv=!cvo1!.!cvo2!
set %3=!cvo1!.!cvo2!
rem exit :calcvaluepct
exit /b

:getvaluefromtextsosearch
set getvaluetexttosearch=%~2
set getvaluetexttosearchfor=%~3
set getvaluetoreturn=%4
call :strlen getvaluetexttosearchlength "!getvaluetexttosearch!"
call :strlen getvaluetexttosearchforlength "!getvaluetexttosearchfor!"
set /A getvaluesearchlinemax=getvaluetexttosearchlength-getvaluetexttosearchforlength
set /A getvaluefounditcolumn=0
for /L %%S in (1,1,!getvaluesearchlinemax!) DO (
call set getvaluesearchitem=!getvaluetexttosearch:~%%S,%getvaluetexttosearchforlength%!
if !getvaluesearchitem! EQU !getvaluetexttosearchfor! (
set /A getvaluefounditcolumn=%%S+getvaluetexttosearchforlength
rem if !getvaluesearchitem! EQU !getvaluetexttosearchfor! (
)
rem for /L %%S in (1,1,!getvaluesearchlinemax!) DO (
)
call set getvaluetexttosearchwhatsleft=%%getvaluetexttosearch:~%getvaluefounditcolumn%%%
for /F "tokens=1,2,3,4" %%B in ('echo !getvaluetexttosearchwhatsleft!') do (
if !getvaluetoreturn! EQU 1 set %~1=%%B
if !getvaluetoreturn! EQU 2 set %~1=%%C
if !getvaluetoreturn! EQU 3 set %~1=%%D
if !getvaluetoreturn! EQU 4 set %~1=%%E
rem for /F "tokens=1,2,3,4" %%B in ('echo !getvaluetexttosearchwhatsleft!') do (
)
rem exit :getvaluefromtextsosearch
exit /b

:strlen
rem :strlen <resultVar> <stringVar>
rem based on function by jep
rem url http://stackoverflow.com/questions/5837418/how-do-you-get-the-string-length-in-a-batch-file   
set s=%~2
set len=0
if [!s!] NEQ [] (
set len=1
for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
if [!s:~%%P^,1!] NEQ [] (
set /a len+=%%P
set s=!s:~%%P!
rem if "!s:~%%P,1!" NEQ "" (
)
rem for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
)
rem if [!s!] NEQ [] (
)
set %~1=%len%
rem exit :strlen
exit /b

:datemath
   SETLOCAL
   :: DateMath, a general purpose date math routine
   
   :: If DateMath detects an error, variable _dd_int is set to 999999.
   SET v_dd_int=0
   SET v_mm_int=0 
   SET v_yy_int=0
   SET v_ymd_str=
   SET v_mm_str=
   SET v_dd_str=
   
   IF "%3"=="" goto :s_syntax
   IF "%4"=="+" goto :s_validate_year
   IF "%4"=="-" goto :s_validate_year
   IF "%4"=="" goto :s_validate_year
   
   :s_syntax
   @ECHO.
   @ECHO DATEMATH SYNTAX:
   @ECHO _______________
   @ECHO.
   @ECHO DateMath will set the variables as listed below
   @ECHO 'str' variables include leading zeros e.g. "01"
   @ECHO 'int' variables leading zeros are stripped e.g. "1"
   @ECHO.
   @ECHO CALL DateMath YY MM DD - YY2 MM2 DD2
   @ECHO.
   @ECHO Will set variable _dd_int to the signed difference
   @ECHO between the 2 dates (measured in days)
   @ECHO.
   @ECHO.
   @ECHO CALL DateMath YY MM DD +/- Days
   @ECHO.
   @ECHO Will set the following variables to the result of
   @ECHO adding or substracting days from the initial date:
   @ECHO    _ymd_str,  _yy_int
   @ECHO    _mm_str, _mm_int,
   @ECHO    _dd_str, _dd_int
   @ECHO.
   @ECHO.
   @ECHO ___________________________________
   pause

   @ECHO.
   @ECHO.
   @ECHO CALL DateMath YY MM DD
   @ECHO.
   @ECHO Will set the following variables:
   @ECHO    _ymd_str,  _yy_int
   @ECHO    _mm_str, _mm_int,
   @ECHO    _dd_str, _dd_int
   @ECHO.
   @ECHO ___________________________________
   @ECHO.
   @ECHO _ymd_str is in YYYYMMDD format.
   @ECHO.
   @ECHO _yy_int is in YYYY format, even if YY format was originally supplied.
   @ECHO This conversion is useful for FAT/NTFS file dates which are in YY format.
   @ECHO.

   ENDLOCAL & SET /a _dd_int=999999
   goto :eof

   :s_validate_year
   ::strip leading zeros
    SET v_yy=%1
    if %v_yy:~0,1% EQU 0 set v_yy=%v_yy:~1%

    :: Check for Y2K
    IF %v_yy% LSS 100 IF %v_yy% GEQ 80 SET /A v_yy += 1900
    IF %v_yy% LSS 80 SET /A v_yy += 2000
    
    :: at this point v_yy contains a 4 digit year

   ::validate month and day
    if %2 GTR 12 goto :s_syntax
    if %3 GTR 31 goto :s_syntax

    SET v_mm=%2
    SET v_dd=%3

    ::strip leading zeros
    if %v_mm:~0,1% EQU 0 set v_mm=%v_mm:~1%
    if %v_dd:~0,1% EQU 0 set v_dd=%v_dd:~1%

   :: Set the int variables
    SET /a v_dd_int=%v_dd%
    SET /a v_yy_int=%v_yy%
    SET /a v_mm_int=%v_mm%

   :: Determine which function to perform - ADD, SUBTRACT or CONVERT

    If not "%6"=="" goto :s_validate_2nd_date
    if "%4"=="" goto :s_convert_only

   :: Add or subtract  days to a date
    SET /a v_number_of_days=%5
    goto :s_add_or_subtract_days

   :s_convert_only

    SET /a v_dd_int=%v_dd%
    IF %v_dd% LEQ 9 (SET v_dd_str=0%v_dd%) ELSE (SET v_dd_str=%v_dd%)
    IF %v_mm% LEQ 9 (SET v_mm_str=0%v_mm%) ELSE (SET v_mm_str=%v_mm%)
    SET v_ymd_str=%v_yy%%v_mm_str%%v_dd_str%

   if [%dmatecho%] EQU [YES] @ECHO DATEMATH - Convert date only (no maths)
   goto :s_end
   ::::::::::::::::::::::::::::::::::::::::::::::::::
   
   :s_validate_2nd_date
    If "%4"=="+" goto :s_syntax
    :: Subtracting one date from another ::::::
    :: strip leading zero
    SET v_yy2=%5
    if %v_yy2:~0,1% EQU 0 set v_yy2=%v_yy2:~1%

    if %v_yy2% GTR 99 goto :s_validate2nd_month
    if %v_yy2% GTR 49 goto :s_prefix_2_1950_1999
    if %v_yy2% LSS 10 goto :s_prefix_2_2000_2009
    SET v_yy2=20%v_yy2%
    goto :s_validate2nd_month

   :s_prefix_2_2000_2009
    SET v_yy2=200%v_yy2%
    goto :s_validate2nd_month

   :s_prefix_2_1950_1999
    SET v_yy2=19%v_yy2%

   :s_validate2nd_month
    ::strip leading zeros
    ::SET /a v_yy2=%v_yy2%
    if %v_yy2:~0,1% EQU 0 set v_yy2=%v_yy2:~1%
    ::v_yy2 now contains a 4 digit year

    if %6 GTR 12 goto :s_syntax
    SET v_mm2=%6

    if %7 GTR 31 goto :s_syntax
    SET v_dd2=%7

    ::strip leading zeros
    ::SET /a v_mm2=%v_mm2%
    if %v_mm2:~0,1% EQU 0 set v_mm2=%v_mm2:~1%
    ::SET /a v_dd2=%v_dd2%
    if %v_dd2:~0,1% EQU 0 set v_dd2=%v_dd2:~1%

   call :s_julian_day %v_yy_int% %v_mm_int% %v_dd_int%
   SET v_sumdays1=%v_JulianDay%

   call :s_julian_day %v_yy2% %v_mm2% %v_dd2%
   SET v_sumdays2=%v_JulianDay%
   
   SET /a v_dd_int=%v_sumdays1% - %v_sumdays2%
   
   if [%dmatecho%] EQU [YES] @ECHO DATEMATH - Subtracting one date from another = days difference
   if [%dmatecho%] EQU [YES] @ECHO ~~~~~~
   if [%dmatecho%] EQU [YES] @ECHO %v_dd_int%
   if [%dmatecho%] EQU [YES] @ECHO ~~~~~~
   goto :s_end_days
   ::::::::::::::::::::::::::::::::::::::::::::::::::
   
   :s_add_or_subtract_days
   if /i "%4"=="+" goto :s_add_up_days

   :: Subtract all days ::::::
   SET /a v_dd=%v_dd% - %v_number_of_days%
   
   :s_adjust_month_year
   if %v_dd% GEQ 1 goto :s_add_subtract_days_DONE
   SET /a v_mm=%v_mm% - 1
   if %v_mm% GEQ 1 goto :s_add_days_%v_mm%
   SET /a v_yy=%v_yy% - 1
   SET /a v_mm=%v_mm% + 12
   goto :s_add_days_%v_mm%
   
   :s_add_days_2
   SET /a v_dd=%v_dd% + 28
   SET /a v_leapyear=%v_yy% / 4
   SET /a v_leapyear=%v_leapyear% * 4
   if %v_leapyear% NEQ %v_yy% goto :s_adjust_month_year
   SET /a v_dd=%v_dd% + 1
   goto :s_adjust_month_year
    
   :s_add_days_4
   :s_add_days_6
   :s_add_days_9
   :s_add_days_11
   SET /a v_dd=%v_dd% + 30
   goto :s_adjust_month_year

   :s_add_days_1
   :s_add_days_3
   :s_add_days_5
   :s_add_days_7
   :s_add_days_8
   :s_add_days_10
   :s_add_days_12
   SET /a v_dd=%v_dd% + 31
   goto :s_adjust_month_year
 
   :s_add_up_days
   :: add all days ::::::
   SET /a v_dd=%v_dd% + %v_number_of_days%
   
   :s_subtract_days_
   goto :s_subtract_days_%v_mm%
     
   :s_adjust_mth_yr
   SET /a v_mm=%v_mm% + 1
   if %v_mm% LEQ 12 goto :s_subtract_days_%v_mm%
   SET /a v_yy=%v_yy% + 1
   SET /a v_mm=%v_mm% - 12
   goto :s_subtract_days_%v_mm%

   :s_subtract_days_2
   SET /a v_leapyear=%v_yy% / 4
   SET /a v_leapyear=%v_leapyear% * 4
   If %v_leapyear% EQU %v_yy% goto :s_subtract_leapyear

   if %v_dd% LEQ 28 goto :s_add_subtract_days_DONE
   SET /a v_dd=%v_dd% - 28
   goto :s_adjust_mth_yr
   
   :s_subtract_leapyear
   if %v_dd% LEQ 29 goto :s_add_subtract_days_DONE
   SET /a v_dd=%v_dd% - 29
   goto :s_adjust_mth_yr
   
   :s_subtract_days_4
   :s_subtract_days_6
   :s_subtract_days_9
   :s_subtract_days_11
   if %v_dd% LEQ 30 goto :s_add_subtract_days_DONE
   SET /a v_dd=%v_dd% - 30
   goto :s_adjust_mth_yr

   :s_subtract_days_1
   :s_subtract_days_3
   :s_subtract_days_5
   :s_subtract_days_7
   :s_subtract_days_8
   :s_subtract_days_10
   :s_subtract_days_12
   if %v_dd% LEQ 31 goto :s_add_subtract_days_DONE
   SET /a v_dd=%v_dd% - 31
   goto :s_adjust_mth_yr

   :s_add_subtract_days_DONE
   SET /a v_dd_int=%v_dd%
   SET /a v_mm_int=%v_mm%
   SET /a v_yy_int=%v_yy%
   IF %v_dd% GTR 9 (SET v_dd_str=%v_dd%) ELSE (SET v_dd_str=0%v_dd%)
   IF %v_mm% GTR 9 (SET v_mm_str=%v_mm%) ELSE (SET v_mm_str=0%v_mm%)
   SET v_ymd_str=%v_yy%%v_mm_str%%v_dd_str%
   
   if [%dmatecho%] EQU [YES] @ECHO DATEMATH - add or subtract days from a date = new date
   goto :s_end
   ::::::::::::::::::::::::::::::::::::::::::::::::::

   :s_julian_day
   SET v_year=%1
   SET v_month=%2
   SET v_day=%3
   
   SET /a v_month=v_month
   SET /a v_day=v_day
   
   SET /A a = 14 - v_month
   SET /A a /= 12
   SET /A y = v_year + 4800 - a
   SET /A m = v_month + 12 * a - 3
   SET /A m = 153 * m + 2
   SET /A m /= 5
   SET /A v_JulianDay = v_day + m + 365 * y + y / 4 - y / 100 + y / 400 - 32045
   
   if [%dmatecho%] EQU [YES] @ECHO The Julian Day is [%v_JulianDay%]
   goto :eof
   ::::::::::::::::::::::::::::::::::::::::::::::::::
   
   :s_end
   if [%dmatecho%] EQU [YES] @ECHO ~~~~~~~~~~~~
   if [%dmatecho%] EQU [YES] @ECHO [%v_ymd_str%] YY=[%v_yy_int%] MM=[%v_mm_str%] DD=[%v_dd_str%]
   if [%dmatecho%] EQU [YES] @ECHO ~~~~~~~~~~~~
   :s_end_days
   ENDLOCAL&SET /a _yy_int=%v_yy_int%&SET /a _mm_int=%v_mm_int%&SET /a _dd_int=%v_dd_int%&SET _ymd_str=%v_ymd_str%&SET _mm_str=%v_mm_str%&SET _dd_str=%v_dd_str%
rem exit :datemath
exit /b

:formatvalueoutput
set "fillernoutvalue2=%outputfiller%%outvaluepart2%"
(call set outvaluepart2chop=%%fillernoutvalue2:~-%putvalueherevalue%%%)
set outvaluepart2format=%outvaluepart2chop:`= %
set %1=%outvaluepart1%%outvaluepart2format%
rem exit :formatvalueoutput
exit /b

:eocuhtothelineformat
set outputpart1nfiller=%outputpart1%%outputfiller%
(call set outputpart1chop=%%outputpart1nfiller:~0,%putvaluehere%%%)
set outputpart1format=%outputpart1chop:`= %
set %1=%outputpart1format%%outputpart2%
rem exit :eocuhtothelineformat
exit /b

:eocuhtotheline
call :eocuhtothelineformat formattedline
echo %formattedline%
rem leaving :eocuhtotheline
rem exit :eocuhtotheline
exit /b

:endthis
if [%errorset%] NEQ [yes] (
if [%cyr%] GTR [] (
@ECHO End date: %cyr%%pcdatefmtdelim%%cmo%%pcdatefmtdelim%%cdy%
rem if [%cyr%] GTR [] (
)
rem if [%errorset%] NEQ [yes] (
)
if exist "%boincinfofileprefix%*-%runforcomputer%_*.txt" del "%boincinfofileprefix%*-%runforcomputer%_*.txt"
endlocal EnableDelayedExpansion
pause